<?php
// $Id: Array.php,v 1.1.2.1 2011/01/04 18:25:40 pounard Exp $

/**
 * Specific implementation.
 */
class Xoxo_Code_Statement_Array extends Xoxo_Code_Statement
{
  /**
   * (non-PHPdoc)
   * @see Xoxo_Code_Statement::escape()
   */
  public function _escape($value, $inner = FALSE) {

    // Empty arrays are easy.
    if (count($value) == 0) {
      return "array()";
    }

    else {
      $variable = $inner ? NULL : $this->_context->createVariable("array");

      if (!$inner) {
        $this->append($variable . " = array(");
      }

      // Indent.
      $this->_context->indent();

      // Build childs.
      foreach ($value as $key => $current) {

        // Bypass the _escape() method for non empty inner arrays, so the code
        // will gracefully indent and display arrays inside arrays.
        if (is_array($current) && count($current) > 0) {
          $this->append($this->escape($key) . " => array(");
          $this->_escape($current, TRUE);
          $this->append("),");
        }

        // Else simply append values using _escape().
        else {
          $this->append($this->escape($key) ." => " . $this->escape($current) . ",");
        }
      }

      // Unindent.
      $this->_context->unindent();

      if (!$inner) {
        $this->append(");");
      }

      return $variable;
    }
  }
}
