<?php
// $Id: Registrable.php,v 1.1.2.1 2011/01/04 18:25:40 pounard Exp $

/**
 * Specific implementation.
 */
class Xoxo_Code_Statement_Registrable extends Xoxo_Code_Statement
{
  /**
   * Export data from the Xoxo_Object class.
   */
  protected function _appendXoxo_Object(Xoxo_Object $object, $variable) {
    $this
      //->appendComment("Xoxo_Object_Exportable specifics.")
      ->append($variable . "->setStatus(" . $this->escape($object->getStatus()) . ");")
      ->append($variable . "->setName(" . $this->escape($object->getName()) .  ");");
  }

  /**
   * Export data from the Oox_Optionable_Interface interface.
   */
  protected function _appendOptions(Oox_Optionable_Interface $object, $variable) {
    if ($object->getOptionsCount()) {
      //$this->appendComment("Oox_Optionable_Interface specifics.");
      // Iterate and recurse over options. Oox_Optionable can be Oox_Registrable_Interface or
      // Oox_Optionable_Interface instances, and we could benefit from this to generate
      // a clean, serialized data free export code.
      foreach ($object->getOptions() as $name => $value) {
        $this->append($variable . "->setOption(" . $this->escape($name) . ", " .  $this->escape($value) . ");");
      }
    }
  }

  /**
   * (non-PHPdoc)
   * @see Xoxo_Code_Statement::escape()
   */
  public function _escape($value) {
    $variable = $this->_context->createVariable('item');

    $registryType = $this->escape($value->getRegistryType());
    $itemType = $this->escape($value->getType());

    $this
      ->appendComment("Object instanciation using the registry pattern.")
      ->append($variable . " = Oox_Registry::getInstance(" . $registryType . ")->getItem(" . $itemType . ");");

    // But wait, we may also have other goodies to append here.
    if ($value instanceof Xoxo_Object_Exportable)  {
      $this->_appendXoxo_Object($value, $variable);
    }
    if ($value instanceof Oox_Optionable_Interface)  {
      $this->_appendOptions($value, $variable);
    }

    return $variable;
  }
}
